﻿Type=Activity
Version=2.65
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim pnlBars, pnlBase As Panel
	Dim gTitle As String
	Dim sampleData As List
	Type sampleDataItem(Date As String, value As String)
	'Declare the Database
	Dim BD As BarData
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Show a progress dialog the time for building the graphic
	ProgressDialogShow2("Compute the chart, that may a bit long", True)
	DoEvents
	DoEvents
	'Load the layout
	Activity.LoadLayout("graphLayout")
	'Determine the Device screen size
	Dim LV As LayoutValues
	LV = GetDeviceLayoutValues
	'Put the panel of layout centered in screen with the max size
	'For the left calculate the difference between the device layout width & the panel
	'width, divide the result by two. For the height we must tale care about the other
	'componenents like the satus bar, then we calculate also the difference between
	'the device layout height and the activity height. For find the right position we
	'substract this size from device layout height before divide the difference by two
	pnlBase.Width = (LV.Width-30)
	pnlBase.Height = (pnlBase.Width/3)*2
	pnlBase.Left = (LV.Width - pnlBase.Width) / 2
	pnlBase.Top = (Activity.Height - pnlBase.Height) / 2
	'Make Is color transparent
	pnlBase.Color = Colors.Transparent
End Sub

Sub Activity_Resume
	'Initalise the list
	sampleData.Initialize
	'Initialise the title of graphic
	gTitle = "Sample candles chart"
	'Variables for the sample
	Dim ind As Int
	Dim candleRND As Float
	For ind = 0 To 17
		'Add some data in the list
		Dim sampleDataItemForCompute As sampleDataItem 'create a new item
		sampleDataItemForCompute.Initialize
		'Put a date, i compute it with date functions, see B4A help for more infos
		sampleDataItemForCompute.Date = DateTime.Date(DateTime.Add(DateTime.DateParse("04/30/2013"),0,0,- ind))
		'Put a random value
		candleRND = Rnd(53,55) + (Rnd(2,7)/10)
		sampleDataItemForCompute.value = candleRND
		'Add the entry
		sampleData.Add(sampleDataItemForCompute)
	Next
	CreatCandlesTab
End Sub

Sub CreatCandlesTab
	'It is not possible to draw directly on the panel.
	'For that reason we add a panel to a panel.
	pnlBars.Initialize("pnlBars")
	pnlBase.AddView(pnlBars, 0, 0, pnlBase.Width, pnlBase.Height)
	'Declare some variables we use for build the graph
	Dim MaxValue, MinValue As Float
	Dim G As Graph
	'Put a big reference for adjust it
	MinValue = 1000000000
	BD.Initialize
	BD.Target = pnlBars
	BD.BarsWidth = 15dip
	BD.Stacked = False
	Charts.AddCandleColor(BD, Colors.Green)
	Dim histo1, histo2 As sampleDataItem
	'Each candles are a pair we need to read the both, then we use a For Next by 2 in step
	'from the list of points. A frequent mistake, don't forget to sop the For Next at 1 !
	For i = sampleData.Size - 1 To 1 Step -2
		DoEvents
		'Transfert the actual item in list
		histo1 = sampleData.Get(i)
		histo2 = sampleData.Get(i-1)
		'Adjust for candle two rounded values for the sample
		Charts.AddCandlePoint(BD, histo1.Date, Array As Float(histo1.value, histo2.value))
		'Update the value min and max
		If MaxValue < histo1.value Then MaxValue = histo1.value
		If MinValue > histo1.value Then MinValue = histo1.value
		If MaxValue < histo2.value Then MaxValue = histo2.value
		If MinValue > histo2.value Then MinValue = histo2.value
	Next
	Dim G As Graph
	G.Initialize
	G.Title = gTitle
	G.XAxis = ""
	G.YAxis = "values"
	G.YStart = MinValue-0.5
	G.YEnd = MaxValue+0.5
	G.YInterval = 0.5
	G.AxisColor = Colors.Black
	Charts.DrawCandlesChart(G, BD, Colors.White)
	ProgressDialogHide
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then 	Activity.Finish
End Sub


